
function onDeployStart()
	SetTriggerCallbacks("Trigger_BadRoute", TriggerEnter_TriggerBadRoute, TriggerExit_TriggerBadRoute)
	SetTriggerCallbacks("Trigger_CorrectRoute", TriggerEnter_TriggerCorrectRoute, TriggerExit_TriggerCorrectRoute)
end
	
function onLevelStart()
	-- set the timer to 3 mins
	SetBattleTimeoutTime(180)
	
	-- set all enemy units to stand ground
	SetEnemyStandGuard(true)
end

function onCameraAnimationFinish(cameraName)

	if cameraName == "CAMERA_INTRO*" then
		ShowDialogDismiss("talkingheads/full/guard","Sir, this force has not noticed us\nI recommend we attack their archers from behind")
	elseif cameraName == "BATTLE_START" then
		AddTargetCircle("Trigger_CorrectRoute")
		ShowGuideArrowForTrigger("Trigger_CorrectRoute")
	end
end

function TriggerEnter_TriggerBadRoute(unit)
	if unit.attacker then
	
		ShowDialog("talkingheads/full/guard", "They've seen us!")
	
		-- set the enemy units to attack
		SetEnemyStandGuard(false)
		
		-- disable everything
		DisableEverything()
	end
end

function TriggerEnter_TriggerCorrectRoute(unit)
	if unit.attacker then
		
		ShowDialog("talkingheads/full/guard", "We've surprised them - attack the archers first!")
		
		-- get the army to attack in a bit
		AddTimer(30,ArmyReactTimer)
		
		-- disable everything
		DisableEverything()
	end
end

function DisableEverything()
	-- turn off all triggers and arrows / circles
	DisableTrigger("Trigger_BadRoute")
	DisableTrigger("Trigger_CorrectRoute")
	ClearTargetCircles()
	--ClearAllGuideArrows()
end

function SetEnemyStandGuard(standGround)
	local enemyUnits = GetUnits("*","*",1)
	for i, unit in pairs(enemyUnits) do
		SetUnitStandGuard(unit,standGround)
	end
end

function ArmyReactTimer()
	
	SetEnemyStandGuard(false)
end