
phase = 0
dropped = 0
spawnturn = 0
destroyed = 0


function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

-- no units alive at start of game so winnable set to false
function onDeployStart()
	createStartingTroops(False)  -- This part here
	SetWinnable(false)
	SetMultipleUnitSelectionButtonEnabled(true)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetStandGuardButtonEnabled(false)
end

-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
	SetVictoryBarEnabled(false)
	SetPanningCamera(18.5, -115.7, 49.8, 0.0, -0.46) -- focusX, focusY, zoom, heading, pitc
	SetStandGuardButtonEnabled(false)
	ShowDialogInPosition("talkingheads/full/Kobar","TXT_FTUE2_BATTLE_4A","BOTTOM_LEFT")
	AddTimer(4.0, removeText)
end

function removeText()
	HideDialog()
end

function createStartingTroops(forPlinthInspector)
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank <= 3 then
			Army = 1
		elseif Rank >= 4 then
			Army = Rank -2
		end
    if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
        SpawnUnits("titan")
		SpawnUnits("spawn")
		SpawnUnits("spawn1")
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowDialogInPosition("talkingheads/full/Kobar","TXT_FTUE2_BATTLE_4A","BOTTOM_LEFT")
		--AddTimer(4.0, removeText)
		ShowDialogInPosition("talkingheads/full/guard","TXT_FTUE_CAMPAIGN_SELECT_ALL","BOTTOM_RIGHT")
		TriggerLesson("MULTISELECT_START_CONFIRM")
		AddTimer(6.0, showFightButton)
		AddTimer(7.0, removeText)
		
		
	end
	if cameraName == "BATTLE_START" then

	end
end

function showFightButton()

	SetFightButtonEnabled(true)

end


function onTalkingHeadFinish(text)
	if text == "TXT_FTUE2_BATTLE_4A" then
		SetFightButtonEnabled(true)
	end
	if text == "TXT_FTUE2_BATTLE_4D" then
		--endit()
	end
end


-- counts the number of dead units, sets the win condition back to true when 8 enemies have been killed
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed +1
		if destroyed == 2 then
			AddTimer(0.5, SpawnUnits, "spawn")
			--AddTimer(0.5, SpawnUnits, "spawn1") 
		end
		if destroyed == 3 then
			AddTimer(0.5, SpawnUnits, "spawn1") 
		end
		if destroyed == 4 then
			PlayVFX("PA_SpawnReinforcement", "pos3")  --PA_CameraSpawnReinforcemen
			AddTimer(1.0, SpawnUnits, "titan") 
			AddTimer(0.1,framecamera)
			AddTimer(1.0, ShowDialogInPosition, "talkingheads/full/Tewin","TXT_FTUE2_BATTLE_4B","BOTTOM_RIGHT")
			AddTimer(6.0, HideDialog)
			AddTimer(6.2, Text)
		end
		if destroyed == 5 then
			ShowDialogInPosition("talkingheads/full/Tewin","TXT_FTUE2_BATTLE_4D","BOTTOM_RIGHT")
			SetWinnable(true)
			Win()
		end
	end
end

function Text()
    ShowDialogInPosition("talkingheads/full/knight","TXT_FTUE2_BATTLE_4C","BOTTOM_RIGHT")
    AddTimer(6.0, HideDialog)
end

function framecamera(seconds)
    FrameCamera("pos1")
    EnableCameraControl(true)
    AddTimer(4.0,ReturnCamera)
end


function endit()
	Win()
end
