-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Army = 2
Titan = 6
Army1 = 1

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
		
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(4.0, enableControls)
	SpawnUnits("Enemy",Army)
	SpawnUnits("Titan",Titan)
	SetTriggerCallbacks("skeletonTrigger", enter_onTriggerEnterSkeleton)
	SetTriggerCallbacks("charge", enter_onTriggerEnterCharge)
end

-- called after the deploy phase
function onLevelStart()
	DisableAiSpells()
	SetTriggerCallbacks("charge", enter_onTriggerEnter)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
end

function enter_onTriggerEnterSkeleton(unit)
	ShowDialogInPosition("talkingheads/full/guard","TXT_AKL_1","BOTTOM_LEFT")
	SpawnUnits("Militia",Army1)
	DisableTrigger("skeletonTrigger")
end

function enter_onTriggerEnterCharge(unit)
	GiveUnitMoveOrder("Enemy","charge")
	GiveUnitMoveOrder("Skeleton","charge")
	DisableTrigger("charge")
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 9 then
			Win()
		end
	end
end

function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("Enemy",Army)
		SpawnUnits("Titan",Titan)
		SpawnUnits("Militia",Army1)
	end
end
