-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
text = 0
Army = 3
Army1 = 4
Titan = 7

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO" then
		EnableCameraControl(false)
		EnableSelectionChange(false)
		SetFightButtonEnabled(false)
	end
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
	SetAutoOrdersButtonEnabled(true)
end

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	AddTimer(4.0, framecamera)
	SetWinnable(false)
	--SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	AddTimer(4.0, enableControls)
	SpawnUnits("WaveCentreRight",Army1)
end

function framecamera()
	ShowDialogInPosition("talkingheads/full/guard","TXT_CAMPAIGN_3B_2_3","BOTTOM_LEFT")
end

-- called after the deploy phase
function onLevelStart()
	SetTriggerCallbacks("charge1", enter_onTriggerEnterRagnar)
	SetTriggerCallbacks("skeleton", enter_onTriggerEnterSkeleton)
	ClearTargetCircles()
	AddTimer(1.0, spawnWave1)
	--AddTimer(50.0, moveUnits)
	SetBattleTimeoutTime(300,0)
	AddTimer(300, Lose)
	SetupVictoryBar()
	SetVictoryBarFill(0)
end

function spawnWave1()
	--SpawnUnits("WaveCentreRight",Army1)
	AddTimer(10.0, spawnWave2)
end

function spawnWave2()
	SpawnUnits("WaveCentreLeft",Army1)
	AddTimer(25.0, spawnWave3)
end

function spawnWave3()
	SpawnUnits("WaveLeft")
	SpawnUnits("WaveRight")
	AddTimer(20.0, spawnWave4)
end

function spawnWave4()
	SpawnUnits("FinalWave",Army)
	SpawnUnits("Titan",Titan)
end

function enableControls()
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	EnableCameraControl(true)
	EnableSelectionChange(true)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 3 then
			SetVictoryBarFill(3/16)
		end
		if destroyed == 6 then
			SetVictoryBarFill(6/16)
		end
		if destroyed == 12 then
			SetVictoryBarFill(12/16)
		end
		if destroyed == 16 then
			SetVictoryBarFill(1.0)
			Win()
		end
	end
end

function moveOrder()
	GiveNamedUnitMoveOrder("FinalWave","claim")	
	GiveNamedUnitMoveOrder("Titan","claim")	
end


function createStartingTroops(forPlinthInspector)
	if forPlinthInspector then
		SpawnUnits("WaveCentreRight",Army1)
		SpawnUnits("WaveCentreLeft",Army1)
		SpawnUnits("WaveLeft")
		SpawnUnits("WaveRight")
		SpawnUnits("FinalWave",Army)
		SpawnUnits("Titan",Titan)
	end
end

function SetupVictoryBar()
	SetVictoryBarType("WAVES")
	AddVictoryBarMarker(3/16)
	AddVictoryBarMarker(6/16)
	AddVictoryBarMarker(12/16)
	AddVictoryBarMarker(1.0)
end
