SpellLevel = 0
Army = 0
Titan = 5
Rank = 0
PlayerUnits = 0
Endpoint = 0
destroyed = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
  QueueVFX("ElderStone_EnergyProp")
  QueueVFX("ElderStone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)
	createStartingTroops(False)
	AddTargetCircle("Area1")
	SetTriggerCallbacks("Area1", Area1_onTriggerEnter, Area1_onTriggerLeave)
	SetTriggerCallbacks("Area3", Area3_onTriggerEnter, Area3_onTriggerLeave)
	SetTriggerCallbacks("Area4", Area4_onTriggerEnter, Area4_onTriggerLeave)
	SetTriggerCallbacks("Area9", Area9_onTriggerEnter, Area9_onTriggerLeave)
	SetTriggerCallbacks("Area6", Area6_onTriggerEnter, Area6_onTriggerLeave)
	SetTriggerCallbacks("Area10", Area10_onTriggerEnter, Area6_onTriggerLeave)
	PlayVFX("ElderStone_EnergyProp", "stone")
	PlayVFX("ElderStone_EnergyPropStones", "stone1")
	PlayVFX("ElderStone_EnergyPropStones", "stone2")
	PlayVFX("ElderStone_EnergyPropStones", "stone3")
	PlayVFX("ElderStone_EnergyPropStones", "stone4")
	PlayVFX("ElderStone_EnergyPropStones", "stone5")
	PlayVFX("ElderStone_EnergyPropStones", "stone6")
	PlayVFX("ElderStone_EnergyPropStones", "stone7")
	PlayVFX("ElderStone_EnergyPropStones", "stone8")
	PlayVFX("ElderStone_EnergyPropStones", "stone9")
	PlayVFX("ElderStone_EnergyPropStones", "stone10")
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
end

function createStartingTroops(forPlinthInspector)
	
	-- Balanced for castle level 5
	SpellLevel = 3
	Army = 6
	Titan = 11

	SpawnUnits("start1",Army)
	
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start1",Army)
		SpawnUnits("Spawn4",Army)
		SpawnUnits("Spawn1",Army)
		SpawnUnits("Spawn2",Army)
		SpawnUnits("spawn3",Titan)
		SpawnUnits("start2",Army)
	end
end

function onLevelStart()
	SetBattleTimeoutTime(360, 0)
	AddTimer(360,Lose)

end

function onCameraAnimationFinish(cameraName)
--	SetTutorial("camera is"..cameraName)
	if cameraName == "CAMERA_INTRO*" then
		--ShowMessageBox("TXT_WINDINGROAD2_1", "TXT_WR2_1")
		ShowDialogInPosition("talkingheads/full/guard","TXT_WR2_1","BOTTOM_LEFT")
		--ShowDialogDismissInPosition("talkingheads/full/guard","TXT_WR2_1A","TOP_LEFT")
		framecamera()
	end
end

function framecamera(seconds)
	FrameCamera("camPrisoners")
	AddTimer(5, ReturnCamera)
	EnableCameraControl(false)
	AddTimer(5.5, enablebuttons)
end

function onTalkingHeadFinish(text)
	if text == "TXT_WR2_1" then
		AddTimer(0.5, enablebuttons)
	end
end

function enablebuttons()
	SetAutoOrdersButtonEnabled(true)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
end

function Area1_onTriggerEnter(unit)		-- spawn friendly captives when defeated first army
	if unit.attacker then
		DisableTrigger("Area1")
		SpawnUnits("Spawn4",Army)
		--ShowDialogInPosition("talkingheads/full/guard","TXT_WR2_4","BOTTOM_LEFT")
		ClearTargetCircles()
		SetAI3()
		fireball()
	end

end

function fireball()
	CastSpell("Fireball", 1, "fb1",.1)
	CastSpell("Fireball", 1, "fb2",.25)
	CastSpell("Fireball", 1, "fb3",0)
	CastSpell("Fireball", 1, "fb4",2)
	CastSpell("Fireball", 1, "fb5",2.7)
	CastSpell("Fireball", 1, "fb6",2.3)

end

function SetAI3()  -- change side from neutral to player
	local units = GetUnits("*", "*", 2)
	for i,unit in pairs(units) do
		SwitchSide(unit , 0)
	end
end



function Area3_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("Area3")
		SpawnUnits("Spawn1",Army)
	end

end


function Area4_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("Area4")
		SpawnUnits("Spawn2",Army)
		--ShowDialog("talkingheads/full/guard","TXT_WR2_3")
	end

end

function Area6_onTriggerEnter(unit)
	if unit.defender then
		DisableTrigger("Area6")
		--ShowDialog("talkingheads/full/guard", "TXT_WR2_2") 
	end
end


function Area9_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("Area9")
		PlayVFX("PA_SpawnReinforcement", "bossspawn")
		AddTimer(2.0, SpawnOneEnemyUnit) 
	end
end

function SpawnOneEnemyUnit()
	SpawnUnits("spawn3",Titan)
	--ShowDialog("talkingheads/full/guard","TXT_WR2_5")
end

function Area10_onTriggerEnter(unit)
	if unit.attacker then
		DisableTrigger("Area10")
		SpawnUnits("start2",Army)
	end

end



--[[function UnitCheck()
	local numberofattackerunits = table.getn( GetUnits("*","*",0) )
	if  numberofattackerunits ==  Endpoint then
		ClearTargetCircles()
		--ClearAllGuideArrows()
		SetWinnable(true)
	end	
end]]


function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
	end
	if destroyed == 2 then
--		ShowMessageBox("TXT_WINDINGROAD2_4A", "TXT_WINDINGROAD2_4")
	end
	if destroyed == 10 then
		Win()
	end
end








