Army = 24
Titan = 32

reinforcementsNotSpawned = true
villageCleared = false

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

function onDeployStart()
	SpawnUnits("titan",Titan)
	SetWinnable(false)
	
	--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10A_6_1")
	
	SetTriggerCallbacks("Advance_Position_Left", onTriggerEnter_Left, onTriggerLeave_Left)
	SetTriggerCallbacks("Advance_Position_Middle", onTriggerEnter_Middle, onTriggerLeave_Middle)
	SetTriggerCallbacks("Advance_Position_Right", onTriggerEnter_Right, onTriggerLeave_Right)
	
end

function onLevelStart()
	
	DisableAiSpells()
	
	
	standGroundUnits = GetUnits("second_force_[START]",Army)
	for i, unit in pairs(standGroundUnits) do
		SetUnitStandGuard(unit,true)
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
	
		--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10A_6_2")
		ShowGuideArrowForTrigger("Village_Area")
		
	end
end

function onUnitDestroyed(unit)
	
	if not villageCleared then
	
		villageUnits = GetUnits("first_force_[START]",Army)
		if #villageUnits <= 0 then
			--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10A_6_3")
			--ClearAllGuideArrows()
			villageCleared = true
		end
		
	else
	
		remainingUnits = GetUnits("*","*",1)
		if #remainingUnits <= 0 then
			if reinforcementsNotSpawned then
				--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10A_6_4")
				SpawnUnits("reinforcementTitan",Titan)
				AddTimer(2,SpawnUnits,"reinforcement_left",Army)
				AddTimer(2,SpawnUnits,"reinforcement_right",Army)
				reinforcementsNotSpawned = false
			else
				AddTimer(1,Win)
			end
		end
	end
	
end

function AdvancePositionTriggered(unit)

	DisableTrigger("Advance_Position_Left")
	DisableTrigger("Advance_Position_Middle")
	DisableTrigger("Advance_Position_Right")
	
	if villageCleared then
		--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10A_6_5")
	else
		--ShowDialog("talkingheads/full/guard", "TXT_CAMPAIGN_10A_6_6")
		--ClearAllGuideArrows()
		villageCleared = true
	end
	
	EnableAiSpells()
	
	standGroundUnits = GetUnits("second_force_[START]",Titan)
	for i, unit in pairs(standGroundUnits) do
		SetUnitStandGuard(unit,false)
	end
	
end

function SpawnUnitWithEffect(unit_ID, respawnNotSpawn)
	PlayVFX("PA_SpawnReinforcement", "Spawn_Effect_" .. unit_ID)
	
	if respawnNotSpawn then
		AddTimer(1,RespawnUnits,"unitSpawn_" .. unit_ID,Army)
	else
		AddTimer(1,SpawnUnits,"unitSpawn_" .. unit_ID,Army)
	end
end

function createStartingTroops(forPlinthInspector)

-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
	end
end

function onTriggerEnter_Left(unit)
	AdvancePositionTriggered(unit)
end
function onTriggerEnter_Middle(unit)
	AdvancePositionTriggered(unit)
end
function onTriggerEnter_Right(unit)
	AdvancePositionTriggered(unit)
end
