-- used to keep track of the number of enemy units
enemyUnits = {}
friendlyUnits = {}
destroyed = 0
spellonce = 0
onemessage = 0
cast = 0
dropped = 0
Army = 1
Army1 = 1

-- called at before the deploy phase
function onDeployStart()
	-- register the triggers in the level
	SetTriggerCallbacks("enemy_attack", onTriggerEnter_trigger_enemy_attack, onTriggerLeave_trigger_enemy_attack)
	createStartingTroops(False)  -- This part here
	DropSpell("Fireball", 5, "SpellDrop")
	DropSpell("Fireball", 5, "SpellDrop1")
	DropSpell("Fireball", 5, "SpellDrop2")
	SpawnUnits("Enemy",Army1)
	SetAutoOrdersButtonEnabled(false)
	SetFightButtonEnabled(false)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetWinnable(false)
	EnableCameraControl(false)
	-- opening message
	AddTimer(4.5, framecamera)
end

-- called after the deploy phase
function onLevelStart()

	cast = 1
	
	-- clear any left over messages
	clearTutorialMessage()
	
end

function createStartingTroops(forPlinthInspector)

	if forPlinthInspector then
		SpawnUnits("Enemy",Army1)
		SpawnUnits("Enemy1",Army1)
	end
	
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			DropSpell("Fireball", 5, "SpellDrop3")
			DropSpell("Fireball", 5, "SpellDrop4")
			DropSpell("Fireball", 5, "SpellDrop5")
			DropSpell("Fireball", 5, "SpellDrop6")
			SpawnUnits("Enemy1",Army1)
		end
		
		if destroyed == 8 then
			Win()
		end
	end
end

function removeText()
	HideDialog()
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "BATTLE_START" then
		--ShowDialog("Portraits/Guard_talkinghead","TXT_CAMPAIGN2A_4_2")
		--DropSpell("Fireball25", 2, "Spell1")
	end
end
 
function clearTutorialMessage()
	-- clear any tutorial messages
	HideDialog()
end

function framecamera(seconds)
    FrameCamera("pos1")
	EnableCameraControl(false)
	ShowDialogEternalInPosition("talkingheads/full/guard","TXT_POPDES_HISTORIAN_INTRO","BOTTOM_LEFT")
	--highlight1()
	AddTimer(5.0, removeText)
	AddTimer(5.0, ReturnCamera)
	AddTimer(6.5, framecamera1)
end

function framecamera1(seconds)
	EnableCameraControl(false)
    FrameCamera("SpellDrop")
	ShowDialogEternal("talkingheads/full/guard","TXT_MISSION9_2")
	highlight3()
	highlight4()
	highlight5()
	AddTimer(4.0, ReturnCamera)
	SetFightButtonEnabled(true)
	SetMultipleUnitSelectionButtonEnabled(true)
	AddTimer(4.0, removeText)
end

function Standstill2() -- tells the unit to stand ground
                local units = GetUnits("*", "*", 0)
                for i,unit in pairs(units) do
                                SetUnitStandGuard(unit, true)
                end
end

function onSpellCollected(spellName, level)
	if spellonce == 0 and cast == 1 then
		playhandswipe()
		AddTimer(5.0,spellOnceIncrease)
	end
end

function spellOnceIncrease()
	spellonce = 10
end
		
function playhandswipe()
	PlayTutorialMovie("Media/UI/Tutorial_SpellCommands.swf")
end

function stophandswipe()
	CloseTutorialMovie("Media/UI/Tutorial_SpellCommands.swf")
end

function onUnitSelected(selectedUnit)
	
	for i, unit in pairs(friendlyUnits) do
		if selectedUnit == unit then
			-- clear all of the move to circles
			ClearTargetCircles()
			break
		end
	end
end

function onSpellCast(spellName, level)
		stophandswipe()
end

function unitsCharge()
	GiveNamedUnitMoveOrder("CapturedTroops", "charge1")
	GiveNamedUnitMoveOrder("CapturedTroops1", "charge2")
end

function highlight3()
	AddTargetCircle("Highlight3")
	AddTimer(5.0, removehighlight)
end

function highlight4()
	AddTargetCircle("Highlight4")
	AddTimer(4.0, removehighlight)
end

function highlight5()
	AddTargetCircle("Highlight5")
	AddTimer(4.0, removehighlight)
end

function removehighlight()
	ClearTargetCircles()
end
