destroyed = 0
SpellLevel = 0
Army = 4
Army1 = 5
Titan = 3
Army6 = 10 -- cutscene militia killed by cutscene titan, NOT COUNTED IN PLINTH INSPECTOR  
Army7 = 30 -- cutscene titan, script killed and removed after cutscene, NOT COUNTED IN PLINTH INSPECTOR

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	SetTriggerCallbacks("spawn1", spawn1_onTriggerEnter)
	SetTriggerCallbacks("spawnRanger", spawnRanger_onTriggerEnter)
	SetTriggerCallbacks("introcamtrigger", introcamtrigger_onTriggerEnter)
	SpawnUnits("start",Army) -- starting enemy troops, 1 pikemen & 2 archers
end

function onLevelStart()
	SetBattleTimeoutTime(300,0)  -- set battle timer for 5 minutes
	EnableCameraControl(false)
end

-- Intro sequence showing Ranger Titan killing a squad of friendly Militia
function introcamtrigger_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(1,killtitanFX)
		AddTimer(2,introscene)
		AddTimer(0.5,camera)
		DisableTrigger("introcamtrigger")
	end
end

function killtitanFX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX6")
	PlayVFX("PA_SpawnReinforcement", "militiaFX")
	AddTimer(1,portalFX)
--	AddTimer(1,introscene)
end

function portalFX()
	PlayVFX("Elderstone_EnergyPropStones", "portalFX1")
	PlayVFX("Elderstone_EnergyPropStones", "portalFX2")
	PlayVFX("Elderstone_EnergyPropStones", "portalFX3")
end

function introscene()
	SpawnUnits("titan",Army7) -- cutscene titan
	SpawnUnits("titan1",Army6) -- cutscene militia
--	AddTimer(0.01,camera)
--	FrameCamera("introcam")
	rangerinvulnerable()
	AddTimer(1.0,talkinghead)
	AddTimer(7.0,titanreturn)
	AddTimer(7.5,titaninvuloff)
	AddTimer(4.1,killmilitia)
--	AddTimer(11.0,ReturnCamera)
	AddTimer(8.5,killtitan)
	EnableCameraControl(true)
end
	
function camera()
	FrameCamera("introcam")
	AddTimer(9.0,ReturnCamera)
end

function killmilitia()
	local units = GetUnits("titan1", "*", 0)
	for i,unit in pairs(units) do
		KillUnit(unit)
	end
end

function rangerinvulnerable() -- sets ranger titan for cutscene to not take damage
	local units = GetUnits("titan", "*", 1)
	for i,unit in pairs(units) do
			EnableInvincibility(unit)
	end
end

function titaninvuloff() -- sets ranger titan for cutscene to take damage so he can be killed and then removed
	local units = GetUnits("titan", "*", 1)
	for i,unit in pairs(units) do
			DisableInvincibility(unit)
	end
end

function talkinghead()
	ShowDialogInPosition("talkingheads/full/guard","TXT_RANGERBAT_C1_M1_TH1","BOTTOM_LEFT")
	AddTimer(9.0,stoptalkinghead)
end

function stoptalkinghead()
	HideDialog()
end

function titanreturn(unit)
	local units = GetUnits("titan", "*", 1)
		for i,unit in pairs(units) do
		GiveNamedUnitMoveOrder("titan", "spawnFX6")	
	end
end

function killtitan(unit)
	local units = GetUnits("titan", "*", 1)
		for i,unit in pairs(units) do
		KillUnit(unit)
		HideDeadUnit(unit)
		SpawnUnits("spawnRanger3",Titan) -- real Titan spawn
	end
end

-- First spawners at portal disk just before fort
function spawn1_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(.1, spawnFX1)
		AddTimer(.75, spawnFX2)
		AddTimer(2.5, spawnFX3)
		DisableTrigger("spawn1")
	end
end

function spawnFX1()
	PlayVFX("PA_SpawnReinforcement", "spawnFX1")
	PlayVFX("Elderstone_EnergyPropStones", "spawn1FX1")
	AddTimer(1, spawn1FX)
end

function spawnFX2()
	PlayVFX("PA_SpawnReinforcement", "spawnFX2")
	PlayVFX("Elderstone_EnergyPropStones", "spawn1FX2")
	AddTimer(1, spawn2FX)
end

function spawnFX3()
	PlayVFX("PA_SpawnReinforcement", "spawnFX3")
	PlayVFX("Elderstone_EnergyPropStones", "spawn1FX3")
	AddTimer(1, spawn3FX)
end

function spawn1FX()
	SpawnUnits("spawn1",Army) -- first skeletons 
end

function spawn2FX()
	SpawnUnits("spawn2",Army) -- second skeletons
end

function spawn3FX()
	SpawnUnits("spawn3",Army1) -- archers
end

-- Spawns enemy troops along side Ranger inside fort
function spawnRanger_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(.1, spawn4FX)
		AddTimer(.2, spawn5FX)
--		AddTimer(3.0, spawnFX6) -- used to be the Titan spawn, but he's alive from the beginning now from cutscene
		DisableTrigger("spawnRanger")
	end
end

function spawn4FX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX4")
	AddTimer(1, spawnRanger1) -- skeletons
end

function spawn5FX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX5")
	AddTimer(1, spawnRanger2) -- skeletons
end

--[[
function spawn6FX()
	PlayVFX("PA_SpawnReinforcement", "spawnFX6")
	AddTimer(1, spawnRanger3)
end
--]]

function spawnRanger1()
	SpawnUnits("spawnRanger1",Army)
end

function spawnRanger2()
	SpawnUnits("spawnRanger2",Army)
end

--[[
function spawnRanger3()
	SpawnUnits("spawnRanger3",Army)
end
--]]

function onUnitDestroyed(unit)
--[[
	if unit.id == "titan1" then
		local units = GetUnits("titan", "*", 1)
			for i,unit in pairs(units) do 
			GiveNamedUnitMoveOrder("titan", "spawnFX6")	
		end
	end
--]]
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 10 then -- includes cutscene Titan that gets killed by script
			AddTimer(3.0,endgame)
		end
	end
end

function endgame()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army)
		SpawnUnits("spawn1",Army)
		SpawnUnits("spawn2",Army)
		SpawnUnits("spawn3",Army1)
		SpawnUnits("spawnRanger1",Army)
		SpawnUnits("spawnRanger2",Army)
		SpawnUnits("spawnRanger3",Titan)
	end
end










