destroyed = 0
SpellLevel = 0
Army = 5
Army1 = 5
Titan = 4

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	SetTriggerCallbacks("spawn1", spawn1_onTriggerEnter)
	SetTriggerCallbacks("rangertrigger", rangertrigger_onTriggerEnter)
	SpawnUnits("start",Army) -- 4 militia groups at the 3 portal disks
	AddTimer(2,rangerallyFX)
end

-- spawn in friendly ranger
function rangerallyFX() 
	PlayVFX("PA_SpawnReinforcement", "rangerallyFX")
	AddTimer(1,rangerally)
end	

function rangerally()
	SpawnUnits("rangerally")
	AddTimer(1,talkinghead)
end

function talkinghead()
	ShowDialogInPosition("talkingheads/full/archivist","TXT_RANGERBAT_C1_M2_TH1","BOTTOM_LEFT")
	AddTimer(7,stoptalkinghead)
end

function stoptalkinghead()
	HideDialog()
end

-- set battle timer
function onLevelStart()
--	SetBattleTimeoutTime(300,0)  -- set battle timer for 5 minutes
end

-- "runway lights" spawning sequence for enemy ranger and his minions
function rangertrigger_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(1,spawnFX1a) -- Note: spawn FX not used for spawning have been commented out
		AddTimer(1,spawnFX1b)
		AddTimer(2,spawnFX2a)
		AddTimer(2,spawnFX2b)
		AddTimer(3,spawnFX3a)
		AddTimer(3,spawnFX3b)
		AddTimer(4,spawnFX4a)
		AddTimer(4.5,spawnFX4b)
		AddTimer(5.0,spawnFX4c)
		AddTimer(5.5,spawnFXR1)
		AddTimer(5.75,spawnFXR2)
		AddTimer(6.0,spawnFXR3)
		AddTimer(6.25,spawnFXR4)
		AddTimer(6.50,spawnFXR5)
		AddTimer(6.75,spawnFXR6)
		DisableTrigger("rangertrigger")
	end
end

-- "runway light FX below"
function spawnFX1a()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX1a")
	AddTimer(.5,fx1a)
end

function fx1a()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX1a")
end

function spawnFX1b()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX1b")
	AddTimer(.5,fx1b)
end

function fx1b()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX1b")
end

function spawnFX2a()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX2a")
	AddTimer(.5,fx2a)
end

function fx2a()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX2a")
end

function spawnFX2b()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX2b")
	AddTimer(.5,fx2b)
end

function fx2b()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX2b")
end

function spawnFX3a()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX3a")
	AddTimer(.5,fx3a)
end

function fx3a()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX3a")
end

function spawnFX3b()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX3b")
	AddTimer(.5,fx3b)
end

function fx3b()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX3b")
end

function spawnFX4a()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX4a")
	AddTimer(.5,fx4a)
end

function fx4a()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX4a")
end

function spawnFX4b()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX4b")
	AddTimer(.5,fx4b)
end

function fx4b()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX4b")
end

function spawnFX4c()
--	PlayVFX("PA_SpawnReinforcement", "rangerFX4c")
	AddTimer(.5,fx4c)
end

function fx4c()
	PlayVFX("Elderstone_EnergyPropStones", "rangerFX4c")
end

function spawnFXR1()
	PlayVFX("PA_SpawnReinforcement", "spawnFXR1")
end

function spawnFXR2()
	PlayVFX("PA_SpawnReinforcement", "spawnFXR2")
end

function spawnFXR3()
	PlayVFX("PA_SpawnReinforcement", "spawnFXR3")
end

function spawnFXR4()
	PlayVFX("PA_SpawnReinforcement", "spawnFXR4")
end

function spawnFXR5()
	PlayVFX("PA_SpawnReinforcement", "spawnFXR5")
end

-- spawn FX for the Ranger and minions
function spawnFXR6()
	PlayVFX("PA_SpawnReinforcement", "spawnFXR6")
	PlayVFX("PA_SpawnReinforcement", "spawnFXR7")	
	PlayVFX("PA_SpawnReinforcement", "spawnFXR8")
	PlayVFX("PA_SpawnReinforcement", "spawnFXR9")
	AddTimer(1,TitanDrop)
end

function TitanDrop()
	SpawnUnits("titan",Titan)
	SpawnUnits("pikes",Army1)
	SpawnUnits("militia",Army)
end

-- on enemy death counters
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
--[[
			if destroyed == 3 then
				PlayVFX("PA_SpawnReinforcement", "spawnFX1")
				PlayVFX("PA_SpawnReinforcement", "spawnFX2")
				PlayVFX("PA_SpawnReinforcement", "spawnFX3")
				PlayVFX("PA_SpawnReinforcement", "spawnFX4")
--				AddTimer(1, respawn)
			end
			if destroyed == 6 then
				PlayVFX("PA_SpawnReinforcement", "spawnFX1")
				PlayVFX("PA_SpawnReinforcement", "spawnFX2")
				PlayVFX("PA_SpawnReinforcement", "spawnFX3")
				PlayVFX("PA_SpawnReinforcement", "spawnFX4")
				AddTimer(1, respawn)
			end
			if destroyed == 9 then
				PlayVFX("PA_SpawnReinforcement", "spawnFX1")
				PlayVFX("PA_SpawnReinforcement", "spawnFX2")
				PlayVFX("PA_SpawnReinforcement", "spawnFX3")
				PlayVFX("PA_SpawnReinforcement", "spawnFX4")
				AddTimer(1, respawn)
--]]
			if destroyed == 9 then
				AddTimer(3,win)
		end
	end
end

function win()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
	SpawnUnits("rangerally") -- friendly ranger titan 
	SpawnUnits("start",Army)
	SpawnUnits("titan",Titan)
	SpawnUnits("pikes",Army1)
	SpawnUnits("militia",Army)
	end
end










