destroyed = 0
SpellLevel = 0
Army = 5
Army1 = 6
Titan = 5

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)															-- no enemies start in the mission, win set to false
	SetTriggerCallbacks("spawn1", spawn1_onTriggerEnter)
	SpawnUnits("pikemen",Army)
end

-- set battle timer for 5 minutes
function onLevelStart()
	SetBattleTimeoutTime(300,0)  
end

-- spawns bulk of enemies including titan
function spawn1_onTriggerEnter(unit)
	if unit.attacker then
		AddTimer(.25,portalFX)
		AddTimer(1.00,militiaFX)
		AddTimer(1.25,archersFX)
		AddTimer(2.00,titanFX)
		DisableTrigger("spawn1")
	end
end

function portalFX()
	PlayVFX("Elderstone_EnergyPropStones", "portalstoneFX")
end

function militiaFX()
	PlayVFX("PA_SpawnReinforcement", "militiaFX")
	AddTimer(1,spawnmilitia)
end

function spawnmilitia()
	SpawnUnits("militia",Army)
end

function archersFX()
	PlayVFX("PA_SpawnReinforcement", "archer1FX")
	PlayVFX("PA_SpawnReinforcement", "archer2FX")
	AddTimer(1,spawnarchers)
end

function spawnarchers()
	SpawnUnits("archers",Army1)
end

function titanFX()
	PlayVFX("PA_SpawnReinforcement", "titanFX")
	AddTimer(1,spawntitan)
end

function spawntitan()
	SpawnUnits("titan",Titan)
end

-- on enemy death counter
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 4 then
			AddTimer(1.0,militia2FX)
--			AddTimer(1.5,titanFX)
		end
		if destroyed == 7 then
			AddTimer(3.0,endgame)
		end
	end
end

-- final wave of enemies
function militia2FX()
	PlayVFX("PA_SpawnReinforcement", "militia2aFX")
	PlayVFX("PA_SpawnReinforcement", "militia2bFX")
	AddTimer(1,spawnmilitia2)
end

function spawnmilitia2()
	SpawnUnits("militia2",Army1)
end

-- called end of mission 
function endgame()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("pikemen",Army)
		SpawnUnits("militia",Army)
		SpawnUnits("archers",Army1)
		SpawnUnits("titan",Titan)
		SpawnUnits("militia2",Army1)
	end
end










