destroyed = 0
SpellLevel = 0
Army = 6
Army1 = 5
Army2 = 4
Titan = 5

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
	QueueVFX("Elderstone_EnergyPropStones")
end

function onDeployStart()
	SetWinnable(false)	-- no enemies start in the mission, win set to false
	SpawnUnits("start",Army2)
end

function onLevelStart()
	SetBattleTimeoutTime(300,0)  -- set battle timer for 5 minutes
	SetTriggerCallbacks("spawn1", spawn1_onTriggerEnter)
	SetTriggerCallbacks("moss", moss_onTriggerEnter)	
	AddTimer(1.75,skel1) 
	AddTimer(.50,skel2)
	AddTimer(1.0,skel3)
end

-- pre bridge skel spawns
function skel1()
	SpawnUnits("skel1",Army2)
end

function skel2()
	SpawnUnits("skel2",Army2)
end

function skel3()
	SpawnUnits("skel3",Army2)
end

-- post bridge spawns
function spawn1_onTriggerEnter(unit)
	if unit.attacker then	
		AddTimer(1,pike1FX)
		AddTimer(1.2,pike2FX)
--		AddTimer(1.4,archer1FX)
		AddTimer(1.6,archer2FX)
		AddTimer(2.5,titanFX)
		DisableTrigger("spawn1")
	end
end

-- pike spawns
function pike1FX()
	PlayVFX("PA_SpawnReinforcement", "pike1FX")
	AddTimer(1,pike1spawn)
end

function pike1spawn()
	SpawnUnits("pike1",Army2)
	PlayVFX("Elderstone_EnergyPropStones", "portalFX1")
end

function pike2FX()
	PlayVFX("PA_SpawnReinforcement", "pike2FX")
	AddTimer(1,pike2spawn)
end

function pike2spawn()
	SpawnUnits("pike2",Army2)
end

-- archer spawns
function archer1FX()
	PlayVFX("PA_SpawnReinforcement", "archer1FX")
	AddTimer(1,archer1spawn)
end

--[[
function archer1spawn()
	SpawnUnits("archer1",Army2)
	PlayVFX("Elderstone_EnergyPropStones", "portalFX2")
end
--]]

function archer2FX()
	PlayVFX("PA_SpawnReinforcement", "archer2FX")
	AddTimer(1,archer2spawn)
end

function archer2spawn()
	SpawnUnits("archer2",Army2)
end

-- titan spawn
function titanFX()
	PlayVFX("PA_SpawnReinforcement", "titanFX")
	AddTimer(1,titanspawn)
end

function titanspawn()
	SpawnUnits("titan",Titan)
	PlayVFX("Elderstone_EnergyPropStones", "portalFX3")
end

-- post bridge skell
--[[
function moss_onTriggerEnter(unit)
	if unit.attacker then	
--		AddTimer(1,skel4spawn)
--		AddTimer(1.2,skel5spawn)
--		AddTimer(1.4,moss1FX)
--		AddTimer(1.6,moss2FX)
--		AddTimer(2.5,moss3FX)
		DisableTrigger("moss")
	end
end

function skel4spawn()
	SpawnUnits("skel4",Army)
end

function skel5spawn()
	SpawnUnits("skel5",Army)
end

function moss1FX()
	PlayVFX("PA_SpawnReinforcement", "moss1FX")
	AddTimer(1,moss1spawn)
end

function moss2FX()
	PlayVFX("PA_SpawnReinforcement", "moss2FX")
	AddTimer(1,moss2spawn)
end

function moss2spawn()
	SpawnUnits("moss2",Army)
end

function moss3FX()
	PlayVFX("PA_SpawnReinforcement", "moss3FX")
	AddTimer(1,moss3spawn)
end

function moss3spawn()
	SpawnUnits("moss3",Army)
end
--]]

-- using on enemy death counters to space out mossmane and skel spawns to be more fogiving in gameplay
function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 8 then
			SpawnUnits("skel4",Army1)
			SpawnUnits("moss1",Army1)
			end
		if destroyed == 9 then
--			SpawnUnits("moss2",Army)
			SpawnUnits("skel5",Army1)
		end
		if destroyed == 10 then
--			SpawnUnits("moss3",Army)
--			SpawnUnits("moss1",Army)
		end 
		if destroyed == 11 then
			AddTimer(3.0,endgame)
		end
	end
end

function endgame()
	SetWinnable(true)
end

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]
		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("start",Army2)
		SpawnUnits("skel1",Army2)
		SpawnUnits("skel2",Army2)
		SpawnUnits("skel3",Army2)
		SpawnUnits("pike1",Army2)
		SpawnUnits("pike2",Army2)
--		SpawnUnits("archer1",Army1)
		SpawnUnits("archer2",Army1)
		SpawnUnits("titan",Titan)
		SpawnUnits("skel4",Army1)
		SpawnUnits("skel5",Army1)
		SpawnUnits("moss1",Army1)
	end
end










