destroyed = 0
SpellLevel = 0
Army = 10
Army1 = 11
Titan = 10

function QueueAssets()
	QueueVFX("PA_SpawnReinforcement")
end

function onLevelStart()
	SetTriggerCallbacks("titanReturn",titanReturn_onTriggerEnter)
	SetTriggerCallbacks("titanReturnBackup",titanReturnBackup_onTriggerEnter)	
	SetTriggerCallbacks("spawns",spawns_onTriggerEnter)	
	SetTriggerCallbacks("kill",kill_onTriggerEnter)
	SetBattleTimeoutTime(300,0)  -- set battle timer for 5 minutes
end

function onDeployStart()
	SetWinnable(false) -- no enemies start in the mission, win set to false
	SpawnUnits("titan",Titan) -- spawns enemy titan behind the spell FX curtain
	AddTimer(.5,lightning) -- starts lighting curtain
	AddTimer(1.0,fireball)	-- starts fireball curtain
--	AddTimer(1,titanStandGuard)
end

--[[
function titanStandGuard()
	local units = GetUnits("titan", "*", 1)
	for i,unit in pairs(units) do
		SetUnitStandGuard(unit,true)
	end
end
--]]

-- Titan return "home" functions
function titanReturnBackup_onTriggerEnter(unit)
	if unit.spawnId == "titan" then
		AddTimer(1,gohome)
	end
end

function titanReturn_onTriggerEnter(unit)
	if unit.spawnId == "titan" then
		AddTimer(1,gohome)
	end
end

function gohome()
	GiveNamedUnitMoveOrder("titan", "titanHome")
end

-- lightning curtain
function lightning()
	CastSpell("Lightning", 25, "strikes"..math.random(5), 1)
	AddTimer(math.random(1), lightning)
end

-- fireball curtain
function fireball()
	CastSpell("Fireball", 25, "fire"..math.random(5), 1)
	AddTimer(math.random(3), fireball)
end

--[[
-- kills any friendlies not already killed by spell curtain, just to be sure none get to the enemy titan
function kill_onTriggerEnter(unit)
	if unit.attacker then
	 local units = GetUnits("*", "*", 0)
		for i,unit in pairs(units) do
		KillUnit(unit)
		end
	end
end
--]]

-- this begins the spawn chain for all of the enemies afterwards using the on enemy death counter
function spawns_onTriggerEnter(unit)
	if unit.attacker then
		PlayVFX("PA_SpawnReinforcement", "militiaFX")
		AddTimer(1,militia)
		DisableTrigger("spawns")
	end
end

function militia(unit)
	SpawnUnits("militia",Army)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
			if destroyed == 1 then
				-- spawns a militia on closest disk and an archer on the farthest disk
				PlayVFX("PA_SpawnReinforcement", "militiaFX2")
				PlayVFX("PA_SpawnReinforcement", "archerFX")
				AddTimer(1, spawnMilitia2)
				AddTimer(1, spawnArchers1)
			end
			if destroyed == 3 then
				-- spawns a ragnar on center disk
				PlayVFX("PA_SpawnReinforcement", "ragnarFX")
				AddTimer(1, spawnRagnar1)
			end
			if destroyed == 4 then
				-- spawns 3 mosssmane on center disk
				PlayVFX("PA_SpawnReinforcement", "mossmaneFX1")
				PlayVFX("PA_SpawnReinforcement", "mossmaneFX2")
				PlayVFX("PA_SpawnReinforcement", "mossmaneFX3")
			AddTimer(1, spawnMossmane1) -- 3x
						end
			if destroyed == 7 then
				-- spawns a militia on closest disk and an archer on the farthest disk
				PlayVFX("PA_SpawnReinforcement", "militiaFX3")
				PlayVFX("PA_SpawnReinforcement", "archerFX")
				AddTimer(1, spawnMilitia3)
				AddTimer(1, spawnArchers2)
			end
			if destroyed == 9 then
				-- spawns a ragnar and mossmanes on center disk
				PlayVFX("PA_SpawnReinforcement", "ragnarFX")
				PlayVFX("PA_SpawnReinforcement", "mossmaneFX1")
				PlayVFX("PA_SpawnReinforcement", "mossmaneFX2")
				PlayVFX("PA_SpawnReinforcement", "mossmaneFX3")
				AddTimer(1, spawnRagnar2)
				AddTimer(1, spawnMossmane2) -- 3x
			end
			if destroyed == 13 then
				CancelTimer(fireball)
				CancelTimer(lightning)
			end
			if destroyed == 14 then
				AddTimer(3,win)
		end
	end
end

-- all of the enemy spawn calls
function spawnMilitia2()
	SpawnUnits("militia2",Army)
end

function spawnMilitia3()
	SpawnUnits("militia3",Army2)
end

function spawnArchers1()
	SpawnUnits("archers",Army)
end

function spawnArchers2()
	SpawnUnits("archers2",Army2)
end

function spawnRagnar1()
	SpawnUnits("ragnar",Army)
end

function spawnRagnar2()
	SpawnUnits("ragnar2",Army2)
end

function spawnMossmane1()
	SpawnUnits("mossmane",Army)
end

function spawnMossmane2()
	SpawnUnits("mossmane2",Army2)
end

function win()
	SetWinnable(true)
end

--[[

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 8 then
		    --ShowDialogEternal("talkingheads/full/guard","TXT_CAMPAIGN_RAGNAR9_2")
			AddTimer(6.0,endgame)
		end
	end
end

function endgame()
    HideDialog()
	SetWinnable(true)
end
--]]

function createStartingTroops(forPlinthInspector)
--[[
	Rank = GetPlayerCastleLevel()					-- Could this work as a scaling LUA function if levels ever went above 25 then this wouldnt need changing
		if Rank >= 7 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 12
		elseif Rank == 8 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 14
		elseif Rank == 9 then			
			Army = Rank -2
			Army1 = Rank
			Titan = 16
		elseif Rank == 10 then			
			Army = Rank -2
			Army1 = Rank -1
			Army2 = Rank
			Titan = 18
		elseif Rank == 11 then			
			Army = 9
			Army1 = 11
			Titan = 20
		elseif Rank == 12 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 22
		elseif Rank == 13 then			
			Army = 9
			Army1 = 11
			Titan = 24
		elseif Rank >= 14 then			
			Army = Rank -2
			Army1 = Rank 
			Titan = 26
		end
--]]

		-- For plinth inspector, we want the later waves too
	if forPlinthInspector then
		SpawnUnits("titan",Titan)
		SpawnUnits("militia",Army)
		SpawnUnits("militia2",Army)
		SpawnUnits("militia3",Army2)
		SpawnUnits("archers",Army)
		SpawnUnits("archers2",Army2)
		SpawnUnits("ragnar",Army)
		SpawnUnits("ragnar2",Army2)
		SpawnUnits("mossmane",Army)
		SpawnUnits("mossmane2",Army2)
	end
end










