Army = 1
phase = 0
dropped = 0
spawnturn = 0
destroyed = 0
playonce = 0
notindeployphase = false
spellonce = 0
onemessage = 0
cast = 0
enemymove = 0

function QueueAssets()
  QueueVFX("PA_SpawnReinforcement")
end

-- no units alive at start of game so winnable set to false
function onDeployStart()
	SetWinnable(false)
	EnableSelectionChange(false)
	SpawnUnits("Skeleton_Spell",Army)
	--SpawnUnits("EnemyGroup")
	SetMultipleUnitSelectionButtonEnabled(false)
	SetAutoOrdersButtonEnabled(false)
	--SetWinnable(false)
	createStartingTroops(False)  -- This part here
	SetFightButtonEnabled(false)
	TriggerLesson("BATTLE_START_CONFIRM")
end


-- level starts, remove timer and cinematics, show instructional message, spawn initial set up spells
function onLevelStart()
	SetBattleTimeoutTime(330, 0) -- set battle timer for 6 minutes
	AddTimer(330,Lose)
	SetMultipleUnitSelectionButtonEnabled(false)
	SetWinnable(false)
	Standstill()
	EnableSelectionChange(false)
	DropSpell("Fireball", 5, "drop4")
	--GiveSpellImmediate("Fireball" , 2)
	notindeployphase = true
	cast = 1
	AddTimer(2.0,onSpellCollected)
	SetTriggerCallbacks("Charge", enter_onTriggerEnter)
	
end

function enter_onTriggerEnter(unit)
	if unit.attacker and enemymove == 1 then
		GiveNamedUnitMoveOrder("EnemyGroup", "pos3")
	end
end

function onCameraAnimationFinish(cameraName)
	if cameraName == "CAMERA_INTRO*" then
		ShowDialog("talkingheads/full/guard","TXT_FTUE_CAMPAIGN2A_SPELL1","BOTTOM_LEFT")
		SetFightButtonEnabled(true)
		--AddTimer(4.0, removeText)
	end
end


function removeText()
	HideDialog()
end

function onTalkingHeadFinish(text)
	--if text == "TXT_MISSION9_1_A" then
		--SetFightButtonEnabled(true)
	--end
end


function createStartingTroops(forPlinthInspector) 
	-- Balanced for castle level 4
	if forPlinthInspector then  	-- For plinth inspector, we want the later waves too
		SpawnUnits("Skeleton_Spell",Army)
		SpawnUnits("EnemyGroup",Army)
		SpawnUnits("EnemyGroup2",Army)
	end
end
	
-- Collecting a spoil shpould fire off a trigger to this function
function onSpellCollected(spellName, level)
	if spellonce == 0 and cast == 1 then
		AddTimer(1.0,framecamera)
		playhandswipe()
		if onemessage == 0 then
			--ShowDialogEternalInPosition("talkingheads/full/guard","TXT_SP2A_5","TOP_LEFT")
			--AddTimer(4.0, removeText)
			onemessage = 1
		end
	end
	
	if spellonce == 1 then
		AddTimer(2.0,removehighlight)
	end
end

function framecamera(seconds)
    FrameCamera("pos3")
	AddTargetCircleWithArrow("pos2")
	EnableCameraControl(false)
	EnableSelectionChange(false)
end

function framecamera1(seconds)
	DropSpell("Fireball", 5, "drop1")
	DropSpell("Fireball", 5, "drop2")
	DropSpell("Fireball", 5, "drop3")
	DropSpell("Fireball", 5, "drop5")
	AddTimer(2, showguide)
	EnableSelectionChange(true)
	EnableCameraControl(false)
	AddTimer(2.0, revealGroup)
end

function revealGroup()
 PlayVFX("PA_SpawnReinforcement", "vfx1")
 PlayVFX("PA_SpawnReinforcement", "vfx2")
 PlayVFX("PA_SpawnReinforcement", "vfx3")
 PlayVFX("PA_SpawnReinforcement", "vfx4")
 PlayVFX("PA_SpawnReinforcement", "vfx5")
 AddTimer(1.0, spawnEnemies)
end

function spawnEnemies()
 enemymove = 1
 SpawnUnits("EnemyGroup",Army)
 SpawnUnits("EnemyGroup2",Army)
end

function showguide(seconds)
   AddTargetCircle("circle1")
   --AddTargetCircle("drop2")
   --AddTargetCircle("drop3")
   AddTargetCircle("circle2")
   --ShowDialogEternal("talkingheads/full/guard","TXT_MISSION9_2")
  -- AddTimer(4.0, removeText)
   --FrameCamera("CameraStart")
   AddTimer(2.5,ReturnCamera)
end

-- Using a spell will fire off a trigger to this function
function onSpellCast(spellName, level)
		AddTimer(3.5, newspell)
end

function onUnitDestroyed(unit)
	if unit.defender then
		destroyed = destroyed + 1
		if destroyed == 1 then
			stophandswipe()
			ClearTargetCircles()
			AddTimer(1.0, framecamera1)
			spellonce = 1
			SetMultipleUnitSelectionButtonEnabled(true)
		end
		if destroyed == 6 then
		SetWinnable(true)
		end
	end
end

function playhandswipe()
	TriggerLesson("BATTLE_SPELL_USE")
	AddTimer(0.5, talkinghead)
	PlayTutorialMovie("Media/UI/Tutorial_SpellCommands.swf")
end

function talkinghead()
	ShowDialogInPosition("talkingheads/full/guard","TXT_SP2A_5","TOP_LEFT")
	AddTimer(4.0, removeText)
end

function stophandswipe()
	CloseTutorialMovie("Media/UI/Tutorial_SpellCommands.swf")
end

function removehighlight()
	ClearTargetCircles()
end

function newspell()
		if destroyed == 0 then
			Standstill()
			GiveSpellImmediate("Fireball" , 5)
		end
end

function Standstill() -- tells the unit to stand ground
                local units = GetUnits("Skeleton_Spell", "*", 1)
                for i,unit in pairs(units) do
                                SetUnitStandGuard(unit, true)
                end
                SetCanGrowAwareness("Skeleton_Spell",false)
end

